/**
 * Phonegap DownloadManager Instance plugin
 * Copyright (c) Marcus Dittebrand 2011
 *
 */
var DownloadManager = {
    
    start : function(options)
    {
    	var mapKey = "cb" + DownloadManager.callbackKey++;
    	DownloadManager.callbackMap[mapKey] = 
    	{	
        	onStart : function(){
        		if(options["onStart"])
        			options.onStart();
       		},
        	onError : function(error){
        		if(options["onError"])
        			options.onError();
       			delete DownloadManager.callbackMap[mapKey];
       		},
        	onProgress : function(current){
        		if(options["onProgress"])
        			options.onProgress(current);
       		},
        	onFinish : function(){
        		if(options["onFinish"])
        			options.onFinish();
       			delete DownloadManager.callbackMap[mapKey];
       		}	
   		}
    	var callback = 'DownloadManager.callbackMap.' + mapKey;
        var arguments = {
            url : options.url,
            onError : callback + ".onError",
            onProgress : callback + ".onProgress",
            onFinish : callback + ".onFinish",
        };    	
    	
        return PhoneGap.exec(
        function(){
       		DownloadManager.callbackMap[mapKey].onStart();
       	}, function(){
       		DownloadManager.callbackMap[mapKey].onError();
       	}, "DownloadManager", "startDownload", [arguments]);
    },
    
    callbackMap : {},
    callbackKey : 0
};